
import 'dart:convert';

import 'package:easy_pass_common/dto/create_user_request.dart';
import 'package:easy_pass_common/dto/user.dart';
import 'package:flutter_test/flutter_test.dart';

import '../fixture_reader.dart';

void main() {
  group('Create user request - ', () {

    test('constructor - will initilize internal variables', () async {
      var user = User.fromJson(json.decode(fixture('user.json')));
      var request = CreateUserRequest(user);

      expect(request.path, '/people');
      expect(request.parameters, isNotNull);
      expect(request.parameters['person'], isNotNull);
    });

    test('encode - will convert request parameter to json', () async {
      var user = User.fromJson(json.decode(fixture('user.json')));
      var request = CreateUserRequest(user);

      var encodedObject = json.encode(request.parameters);
      var expectedEncodedObject = '{"person":{"name":"Desmond","surname":"Letshedi","email":"desmond@gmail.com","phone":"0662541612","date_of_birth":"2020-03-19T00:00:00.000","password":"password"}}';
    
      expect(encodedObject, equals(expectedEncodedObject));
    });    
  });
}